#include "stdafx.h"
#include "DatabaseModel.h"

#include <QSqlRecord>
#include <QStringList>

using namespace Model;

QString DatabaseModel::userName_ = "Serg";
QString DatabaseModel::password_ = "12345";
QString DatabaseModel::resourceString_ = ":/FireBirdAndQT/Resources/Model/New.FDB";

DatabaseModel::DatabaseModel()
{

}

DatabaseModel::~DatabaseModel()
{
     Close();
}

void DatabaseModel::Open()
{
    if (fireBirdDatabase_.IsOpen())
    {
        fireBirdDatabase_.Close();
    }    

    QString databasePath = GetFullPath("TEST.FDB");

    bool isOpen = fireBirdDatabase_.Open(databasePath, userName_, password_);

}

bool DatabaseModel::Create()
{
    Close();

    QString testDBPath = GetFullPath("Created.FDB");
    return fireBirdDatabase_.Create(testDBPath, userName_, password_);
}

void DatabaseModel::Close()
{    

    if (fireBirdDatabase_.IsOpen())
    {
        fireBirdDatabase_.Close();
    }
    
}

QString DatabaseModel::GetFullPath(const QString& path)
{
    QString curPath  = QDir::currentPath();
    QDir directory(curPath);
    directory.cdUp();
    bool result = directory.setCurrent("debug");
    directory.cd("debug");
    result = directory.setCurrent("DB");
    directory.cd("DB");
    QString databasePath = directory.filePath(path);
    
    // return back to curPath;
    result = directory.setCurrent(curPath);

    return databasePath;
}
void DatabaseModel::AddJob(const QString& jobName )
{

    QByteArray description("Test description");
    int salary = 1200;

    QSqlQuery query(fireBirdDatabase_.CreateQuery());
    bool result = query.prepare("EXECUTE PROCEDURE SP_INSERT_JOB (?, ?, ?)");
    query.addBindValue(jobName);
    query.addBindValue(salary);
    query.addBindValue(description);
  
    if (!query.exec())
    {
        QString err = query.lastError().text();            
        throw std::runtime_error("Error executing Query.");
    }    
    query.next();
    int jobID = query.value(0).toUInt();
}

void DatabaseModel::SelectJobs(QStringList& jobs )
{
    QSqlQuery query = QSqlQuery(fireBirdDatabase_.CreateQuery());

    QString preparedString = "SELECT JOB_NAME FROM TBL_JOBS";

    query.prepare(preparedString);

    if (!query.exec())
    {
        QString err = query.lastError().text();         
       
        throw std::runtime_error("Error executing Query.");
    }    

    while (query.next())
    { 
        QSqlRecord record = query.record();
        jobs.append(record.value(0).toString());
        
    }
}