#ifndef _FIREBIRD_DATABASE_H_
#define _FIREBIRD_DATABASE_H_

#include <QSqlDatabase>
#include <QSqlError>
#include <QSqlDriver>
#include <QPluginLoader>
#include <QSqlDriverPlugin>
#include <QDir>
#include <QLibrary>
#include <QSqlResult>
#include <QSqlQuery>
#include <QSqlTableModel>
#include <QtSql/qsql.h>

namespace Model
{
    class FireBirdDatabase : public QObject
    {
        Q_OBJECT

    public:
        FireBirdDatabase();
        ~FireBirdDatabase();

        bool Initialize();        
        bool Create(const QString& filePath, const QString& userName, const QString& password);
        bool Open(const QString& filePath, const QString& userName, const QString& password);
        bool Close();
        int LastError();

        bool IsOpen();
        
        QSqlQuery CreateQuery();

    private:
        QPluginLoader pluginLoader_;
        QString databasePath_;
        QString connectionName_;
        QSqlDriver* driver_;
        bool isInitialized_;    
        int instances_;
        int lastError_;

    private:
        static QString qtIBasePluginName_;
        static QString qtIBaseDriverName_;
        static QString connectionString_;

        Q_DISABLE_COPY(FireBirdDatabase);
    };
}
#endif //_FIREBIRD_DATABASE_H_